#ifndef __SYS_H__
#define __SYS_H__	 

#include "LT268C.h" 
#include "type.h"

//0,֧OS
//1,֧OS
#define SYSTEM_SUPPORT_OS		0		//ϵͳļǷ֧OS
///////////////////////////////////////////////////////////////////////////////////

//λ,ʵ51ƵGPIOƹ
//ʵ˼,ο<<CM3Ȩָ>>(87ҳ~92ҳ).M4ͬM3,ֻǼĴַ.
//IOڲ궨
#define BITBAND(addr, bitnum) ((addr & 0xF0000000)+0x2000000+((addr &0xFFFFF)<<5)+(bitnum<<2)) 
#define MEM_ADDR(addr)  *((volatile unsigned long  *)(addr)) 
#define BIT_ADDR(addr, bitnum)   MEM_ADDR(BITBAND(addr, bitnum)) 


extern uint32_t g_sys_clk;	//ϵͳʱȫֱ
extern uint32_t g_ips_clk;
extern uint32_t g_trim_clk;

////////////////////////////////////////////////////////////////////////////////// 

extern void Sys_Soft_Reset(void);      							//ϵͳλ
extern void Sys_Standby(void);         							//ģʽ 	
extern void NVIC_SetVectorTable(uint32_t NVIC_VectTab, uint32_t Offset);	//ƫƵַ
extern void NVIC_PriorityGroupConfig(uint8_t NVIC_Group);			//NVIC
extern void NVIC_Init(uint8_t NVIC_PreemptionPriority,uint8_t NVIC_SubPriority,uint8_t NVIC_Channel,uint8_t NVIC_Group);//ж
extern void Ex_NVIC_Config(uint8_t GPIOx,uint8_t BITx,uint8_t TRIM);				//ⲿжú(ֻGPIOA~I)
extern void Sys_Init(void);

//Ϊຯ
extern void WFI_SET(void);		//ִWFIָ
extern void INTX_DISABLE(void);//رж
extern void INTX_ENABLE(void);	//ж
extern void MSR_MSP(uint32_t addr);	//öջַ 
#endif		/*__SYS_H__*/











