/*******************************************************************************
 * Copyright(c) 2023 Levetop Semiconductor Co.,Led. All rights reserved.
 * @file     transport.h
 * @author   UartTFT Application Team
 * @version  V0.0.1
 * @date     2023-01-01
 * @brief
 ********************************************************************************/

#ifndef _TRANSPORT_H
#define _TRANSPORT_H

#include "data.h"

void LT268_Flash_Read_Model(uint32_t Addr);
void LT_ReadFlash(uint8_t *pBuffer, uint32_t ReadAddr, uint32_t NumByteToRead);
void LT_ReadFlash_DMA(uint8_t *pBuffer, uint32_t ReadAddr, uint32_t NumByteToRead);

void TFT_Data_Tran(uint8_t *Tx_Addr, uint32_t length);
void TFT_Data_Tran2(uint16_t Tx_Addr, uint32_t length);
void TFT_Data_Tran3(uint16_t *Tx_Addr, uint32_t length);
// void TFT_Data_Tran_nand(uint8_t* Tx_Addr, uint32_t length);

#endif /* _TRANSPORT_H */
