/************************************************************************
  * Copyright(c) 2023 Levetop Semiconductor Co.,Led. All rights reserved.
  * @file     wav_dac.h
  * @author   UartTFT Application Team
  * @version  V0.0.1
  * @date     2023-01-01
  * @brief     
 *************************************************************************/

#ifndef _WAV_DAC_H
#define _WAV_DAC_H

#include "type.h"
#include "dac_drv.h"

extern uint8_t wav_reduce_para;
extern uint8_t wav_reduce_para_last;
extern uint8_t gWavFlag;
extern uint8_t gWavType;

uint16_t etARRValue(uint16_t sample);
void DAC_SetData(uint16_t data);
uint8_t LT_PlayWav_DAC(void);
void Wav_DAC_Init(uint16_t num);
void close_wav_dac(void);

//------------------------------------------ WAV ------------------------------
void WAV_amplifier_EN(void);
void WAV_amplifier_DIS(void);

#endif /* _WAV_DAC_H */