// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : usb_cdc_demo.c
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include "string.h"
#include "usb_cdc_demo.h"
#include "usb_drv.h"
#include "type.h"
#include "debug.h"
#include "common.h"
#include "usb_const.h"

uint8_t  cdc_ctl_buf[512];

/*************************************************
Function: USBDev_DoCDCCmd
Description: CCIDĴ
Calls:
Called By:
Input: 
Output: 
Return: 
Others: 
*************************************************/
void USBDev_DoCDCCmd(void)
{
	uint16_t recvLen = 0;
	//uint16_t i = 0;

	memset(cdc_ctl_buf, 0x00, sizeof(cdc_ctl_buf));
	recvLen = usb_cdc_receive(INDEX_EP2, (uint8_t *)cdc_ctl_buf);
	if (recvLen == 0)
		return;
	printf("USB Recv Len = 0x%04x:\r\n", recvLen);
	//for(; i < recvLen; i++)
	printf("%s ", cdc_ctl_buf);
	printf("\r\n");
	usb_cdc_send(INDEX_EP1, (uint8_t*)cdc_ctl_buf, recvLen);
}



void usb_cdc_poll(void)
{
	if( (g_uchUSBStatus & BIT1) == BIT1 )     //յһ
	{
		g_uchUSBStatus &= ~BIT1;
		printf("USBDev_DoCDCCmd\r\n");
		USBDev_DoCDCCmd();
	}
}


void USB_CDC_Demo(void)
{
	printf("USB_CDC_Demo \r\n");
	Disable_Interrupts;
	USB_CDC_Init();
	Enable_Interrupts;

	while(1)
	{
		usb_cdc_poll();
	}
}
