/*
 * iccemv.c
 *
 *  Created on: 2017526
 *      Author: YangWenfeng
 */

#include "stddef.h"
#include "stdarg.h"
#include "stdlib.h"
#include "string.h"
#include "iccemv.h"
#include "pit32_drv.h"
#include "debug.h"

#define EMV_Co_Test
#define   EMV_SW1            asyncard_info[current_slot].sw1
#define   EMV_SW2            asyncard_info[current_slot].sw2

/********************************************************************
 ----------------------------ȫֱ----------------------------
 ********************************************************************/
volatile uint32_t          k_Ic_TotalTimeCount = 0;         //ַܳʱм
volatile uint32_t          k_Ic_TimeCount = 0;              //ַʱм
volatile uint32_t          k_IcMax_TotalTimeCount = 0;      //ܳʱֵ
volatile uint32_t          k_IcMax_TimeCount = 0;           //ַʱֵ
volatile int             k_timeover,k_total_timeover = 0; //ַʱܳʱ־
volatile uint32_t          k_IcMax_EtuCount = 0;           //ַʱֵλETU


static   uint8_t           card_Outputdata[ICMAXBUF];
static   uint8_t           rstbuf[40];
volatile static uint8_t    WTX;
volatile static uint32_t   WWT,CWT,BWT;
volatile  uint8_t          current_slot = 0;
volatile  uint8_t          Parity_Check_Enable; /* żУ󵥸ַط־  */
volatile  uint8_t          k_IccErrPar = 0;       /* żУ    */

vu16                     respLength = 0;
volatile uint8_t           SC_ATR_Table[40];
volatile uint8_t           SC_T0_T1_Status = 0;
volatile uint8_t           SC_ATR_Len = 0;
volatile uint8_t           guc_hotrstFlag = 0;
volatile uint8_t           guc_Leflag = 0;

volatile uint8_t           changeTa1     = 0;          //20110729
volatile uint8_t           guc_AdjustETU = 0;		//ַETUҪ11
volatile uint8_t           guc_GuardTime = 0;		//20131220Ϊint(ԭֵƥ)GTĴΪĬ12ETU
volatile uint8_t           guc_Class = 0;
volatile uint8_t           ICCardResetOK = 0;
volatile uint8_t           ICCardInsert = 0;
volatile uint8_t           ICCardInfoSent = 0;            //icϢͣ00 ʼ״̬   01    02 Ƴ
volatile uint8_t           g_usbCommOK = 0;
ASYNCARD_INFO            asyncard_info[IC_MAXSLOT];

SC_State                 *locState;  //test
SC_ATR                   SC_A2R;
SC_ADPU_Commands         SC_ADPU;
SC_ADPU_Responce         SC_Responce;
SC_READER_SET            SC_Slot_Default= {0,0,0x0A,0x0D,0x04,22,1,2,0x20,0,0,0,0,0,0x6fffff,0x6fffff,SC_POWER_ON};
SC_READER_SET            *SC_Slot_Active=&SC_Slot_Default;

#ifndef ISO7816_PBOC_CARD
const uint16_t FDSelection_Table[30] = {744,0x01,372,0x02,186,0x03,93,0x04,46,0x05,23,0x06,12,0x07,31,0x08,512,0x09,256,0x0A,128,0x0B,64,0x0C,32,0x0D,16,0x0E,8,0x0F};
const uint16_t FI_Table[24] = {0x00,372,0x01,372,0x02,558,0x03,744,0x04,1116,0x05,1488,0x06,1860,0x09,512,0x0A,768,0x0B,1024,0x0C,1536,0x0D,2048};
const uint16_t DI_Table[18] = {0x01,1,0x02,2,0x03,4,0x04,8,0x05,16,0x06,32,0x07,64,0x08,12,0x09,20};

//0ʾTA1
BOOLEAN Get_FiDi(uint8_t TA1, uint16_t *Fi, uint8_t *Di)
{
	uint8_t i;
	uint8_t temp;

	temp = TA1>>4;	
	for (i=0;i<12;i++)
	{
		if (temp == FI_Table[2*i])
		{
			*Fi = FI_Table[2*i+1];
			break;
		}
	}
	if (i == 12)
		return FALSE;
	
	temp = TA1&0x0F;
	for (i=0;i<9;i++)
	{
		if (temp == DI_Table[2*i])
		{
			*Di = DI_Table[2*i+1];
			break;
		}
	}
	if (i == 9)
		return FALSE;

	return TRUE;
}

//0ʾTA1
uint8_t Get_FD_Selection(uint16_t Fi, uint8_t Di)
{
	uint8_t i;
	uint8_t temp;
	uint16_t FdivD;

	FdivD = Fi/Di;		//ȡּ
	for (i=0;i<15;i++)
	{
		if (FdivD == FDSelection_Table[2*i])
		{
			temp = FDSelection_Table[2*i+1];
			break;
		}
	}
	if (i == 15)
		return 0;

	return temp;
}

//ֵ: 0ʾ;1ʾTA1ʹFD2ʾûзTA1ʹĬϵFD;
uint8_t PPS_Process(uint8_t slot)
{
	uint8_t ret;
	uint8_t PPS_Requst[4];
	uint8_t PPS_Response[4];
	uint8_t i;

	//GTWTATRͬ
	
	PPS_Requst[0] = 0xFF;
	PPS_Requst[1] = 0x10+(asyncard_info[slot].TD1&0x0f);
	PPS_Requst[2] = asyncard_info[slot].TA1;
	PPS_Requst[3] = PPS_Requst[0]^PPS_Requst[1]^PPS_Requst[2];

	Parity_Check_Enable=0x00;		//ط
	for (i=0;i<4;i++)
	{
		ret=SC_PutByte(PPS_Requst[i]);
		if(ret)
		{
			return 0;
		}
	}

	if(asyncard_info[slot].TD1==0)
		Parity_Check_Enable=0x01; 		//
	else 
		Parity_Check_Enable=0x00;
	
	//PPSS
	if(SC_GetByte(&PPS_Response[0]) == ERROR)
	{
		return 0;			//ʱطʧܺ󶼻ᵽ
	}
	if (PPS_Response[0] != 0xFF)
		return 0;

	//PPS0
	if(SC_GetByte(&PPS_Response[1]) == ERROR)
	{
		return 0;			//ʱطʧܺ󶼻ᵽ
	}
	if ((PPS_Response[1]&0x0F) != (PPS_Requst[1]&0x0F))
		return 0;

	if ((PPS_Response[1]&0x10) == 0x10)	//PPS1
	{
		//PPS1
		if(SC_GetByte(&PPS_Response[2]) == ERROR)
		{
			return 0;			//ʱطʧܺ󶼻ᵽ
		}
		if (PPS_Response[2] != PPS_Requst[2])
			return 0;

		//XOR
		if(SC_GetByte(&PPS_Response[3]) == ERROR)
		{
			return 0;			//ʱطʧܺ󶼻ᵽ
		}
		if (PPS_Response[3] != PPS_Requst[3])
			return 0;

		return 1;
	}
	else		//ûPPS1
	{
		//XOR
		if(SC_GetByte(&PPS_Response[2]) == ERROR)
		{
			return 0;			//ʱطʧܺ󶼻ᵽ
		}
		if ((PPS_Response[0]^PPS_Response[1]) != PPS_Response[2])
			return 0;

		return 2;
	}
}
#endif

/*******************************************************************************
* Function Name  : PIT2Open
* Description    : PIT2
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void PIT2Open()
{
	PIT32_Init(PIT32_CLK_DIV_1024, 58,TRUE);   //1ms  --ywf:̫СCASE1702޷ͨÿοPTI¿ʼ
}

/*******************************************************************************
* Function Name  : PIT2Close
* Description    : PIT2ر
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void PIT2Close()
{
	PIT32_Stop();
}

/*******************************************************************************
* Function Name  : Icc_Reset
* Description    :ʼSLOTͨICԿϵ磬λжϿЭͣ
*                 T=1T=0ATRλӦ𣩶*ATRָ⡣
* Input          : slot Ҫʼͨ
*                  ATR  ATRBUF
*
* Output         : None
* Return         : None
******************************************************************************/
int Icc_Reset(uint8_t slot,uint8_t *ATR)
{
 	int ret=0, temp=0;
#ifdef debug_print
 	int i=0;
#endif
#ifndef ISO7816_PBOC_CARD
	uint8_t usibound;
#endif

 	ClearAtr(slot);//ATR

	asyncard_info[slot].T=0;
	guc_AdjustETU = 0;
	guc_GuardTime = 0;
	changeTa1 = 0;

	ret=GetAtr(rstbuf);
	PIT2Close();

#ifdef debug_print
	printf ("atr:");
	for (i=0; i<rstbuf[0]; i++)
	{
		printf ("%02x",rstbuf[1+i]);
	}
	printf ("\n");
#endif

	// 201312311CE079Ųǰȸλǰ޸˼Ĵ
	if(asyncard_info[slot].resetstatus==0)
	{
		asyncard_info[slot].resetstatus=0x01;
	}
	else
	{
		asyncard_info[slot].resetstatus=0x02;
	}
	if(ret)
	{
#ifdef debug_print
		printf ("atr error!\n");
		printf ("ret = %4d!\n",ret);
#endif

		if((ret!=ICC_ATR_TSERR)&&(ret!=ICC_ATR_TIMEOUT)
		 &&(ret!=ICC_PARERR)   &&(ret!=ICC_ATR_TCKERR)
		 &&(asyncard_info[slot].resetstatus==0x01) )
		{
			guc_hotrstFlag = 1;
		}
		// TS󣬳ʱУ顢TCKдͷ
		return ret;
	}
#ifdef debug_print
		printf ("atr ok!\n");
#endif


#ifndef ISO7816_PBOC_CARD		//ִPPS
	if(asyncard_info[slot].TA & 0X02)		//ģʽ
	{
		 if(asyncard_info[slot].TA2 & 0x10)	//Ĭϲ޸
		 {
		 }
		 else		//սӿֽڲATRеĲ
		 {
			if(asyncard_info[slot].TA & 0X01)		//TA1
			{
				usibound = Get_FD_Selection(asyncard_info[slot].F, asyncard_info[slot].D);
				if (usibound != 0)
				{
					g_USIReg->USIBDR = usibound;
				}
			}
		 }
	}
	else		//ЭģʽPPS
	{
		if(asyncard_info[slot].TA & 0X01)		//TA1
		{
			usibound = Get_FD_Selection(asyncard_info[slot].F, asyncard_info[slot].D);
		}
		else		//TA1ʹTA1=18
		{
			asyncard_info[slot].TA1 = 0x18;
			if (Get_FiDi(asyncard_info[slot].TA1, &asyncard_info[slot].F, &asyncard_info[slot].D) == FALSE)
			{
				return ICC_PARERR;
			}
			usibound = Get_FD_Selection(asyncard_info[slot].F, asyncard_info[slot].D);
		}
		if (usibound != 0)
		{
			DelayNETU(22+2);		//򱣻ʱ
			//ִPPS
			temp = PPS_Process(slot);
			if (temp == 0)
			{				
				return ICC_PARERR;		//ִµ
			}
			else if (temp == 1)	//޸
			{
				g_USIReg->USIBDR = usibound;
			}
		}
	}
#else		//PBOC
	//ͨѶת
	if((asyncard_info[current_slot].D==1)
	 ||(asyncard_info[current_slot].D==2)
	 ||(asyncard_info[current_slot].D==4))//ͨѶת
	{
		changeTa1=0;
		g_USIReg->USIBDR = 2;
		if(asyncard_info[current_slot].D==2)
		{
			changeTa1=2;
			g_USIReg->USIBDR = 3;
		}
		if(asyncard_info[current_slot].D==4)
		{
			changeTa1=4;
			g_USIReg->USIBDR = 4;
		}
	}
#endif

	//ͨѶЭת
	if ((asyncard_info[slot].TD1&0x0f)==0x01) //
	{
		g_USIReg->USICR1 = g_USIReg->USICR1 | 0x08;	// t=1;
		asyncard_info[slot].T=1;
		asyncard_info[slot].term_pcb=0x00;
		SC_Slot_Active->SC_Protocol=T1_PROTOCOL;
	}
	else if ((asyncard_info[slot].TD1&0x0f)==0x00)
	{
		g_USIReg->USICR1 = g_USIReg->USICR1 & 0xf7;	// t=0;
		asyncard_info[slot].T=0;
		SC_Slot_Active->SC_Protocol=T0_PROTOCOL;
	}
	else
	{
		return ICC_PROTOCALERR;
	}

	 // RSTBUFʽ:+TS+TO+TA......
	for( temp=0 ; temp<rstbuf[0] ; temp++ )
	{
		*(ATR+temp) = rstbuf[temp+1];
	}
	SC_ATR_Len = rstbuf[0];

	//ͨѶETU
	if(asyncard_info[current_slot].TC1 != 0xff)
	{
		temp = asyncard_info[current_slot].TC1 + 12;
		guc_GuardTime = temp;
	}
	else
	{
		if(asyncard_info[slot].T==1)
		{
			temp = 11;
			guc_GuardTime = temp;
		}
		if(asyncard_info[slot].T==0)
		{
			temp = 12;
			guc_GuardTime = temp;
		}
	}
	guc_GuardTime = temp;
	g_USIReg->USIGTRL = (unsigned char)(temp & 0xff);
	g_USIReg->USIGTRH = (unsigned char)((temp>>8) & 0xff);

	//asyncard_info[slot].open =1;

	//T1ЭIFS
	if(asyncard_info[slot].T==1)
	{
		//ԤôICյIȷPCB֣˳1
		asyncard_info[slot].card_pcb=0x40;
		ret=T1_IFSD_command(0);
		return ret;
	}
	return ICC_SUCCESS;
}

/*******************************************************************************
* Function Name  : Icc_Command
* Description    :
*                 ֧T0ЭT1Э
*                 ֧CASE2͵
* Input          : slot     ˿
*                  ApduSend APDU
*                  ApduResp Ӧ
*
* Output         : None
* Return         : ز
******************************************************************************/
int Icc_Command(uint8_t slot,SC_ADPU_Commands * ApduSend,SC_ADPU_Responce * ApduResp)
{
	uint8_t   Cla,Ins,P1,P2;
	uint16_t  Le,Lc,iT1Le,recelen;
	int     result;
	//uint8_t   *ptr;

	EMV_SW1=0;
	EMV_SW2=0;
	ApduResp->SW1=0;
	ApduResp->SW2=0;
	if((ApduSend==NULL)||(ApduResp==NULL))
		return ICC_PARAMETERERR;

	if(asyncard_info[current_slot].T==0)		 //T=0Э鿨ƬӦżУط
		Parity_Check_Enable=0x01;
	else
		Parity_Check_Enable=0x00;

	Cla=ApduSend->Header.CLA;
	Ins=ApduSend->Header.INS;
	P1= ApduSend->Header.P1;
	P2= ApduSend->Header.P2;
	Lc= (uint16_t )(ApduSend->Body.LC);//͵ݳ
	if(Lc>ICMAXBUF)
	{
		Parity_Check_Enable=0x00;
		return ICC_DATA_LENTHERR;
	}
	//յӦݳ
	Le= (uint16_t)(ApduSend->Body.LE);
	if (Le > 256)
	{
		Le=256;
	}
	if( guc_Leflag == 1)//Ҫ·LE־
	{
		guc_Leflag = 0;
		Le = 256;
	}

	result=IccSendCommand( Cla,Ins, P1, P2,  Lc,ApduSend->Body.Data,Le,card_Outputdata);
	Parity_Check_Enable=0x00;
	//ptr=ApduResp->Data;
	if((asyncard_info[current_slot].T==1) && (result==0))
	{
		//ΪT=1Эҽȷʱнݸʽת
		iT1Le = card_Outputdata[0]*256 +card_Outputdata[1];
		recelen=iT1Le-2;
		if(recelen>0)
		memcpy(ApduResp->Data,&card_Outputdata[2],recelen);

		ApduResp->SW1 = card_Outputdata[iT1Le];
		ApduResp->SW2 = card_Outputdata[iT1Le+1];
		respLength = recelen+2;
	}
	else if(result==0)
	{
		//T=0Эҽȷʱиʽת
		recelen=card_Outputdata[0]*256+card_Outputdata[1];
		if(recelen>0)
		memcpy(ApduResp->Data,&card_Outputdata[2],recelen);

		respLength = recelen+2;

		ApduResp->SW1=EMV_SW1;
		ApduResp->SW2=EMV_SW2;
	}
	else
	{
		// respLengthʼΪ0
		EMV_SW1=0;    EMV_SW2=0;

		ApduResp->SW1=0;
		ApduResp->SW2=0;

		if((result==ICC_T0_TIMEOUT)||(result==ICC_T1_BWTERR)||(result==ICC_T1_CWTERR))
			return ICC_ICCMESSOVERTIME;
	}
	return  result;
}

/*******************************************************************************
* Function Name  : exp2_n
* Description    :2Nη
* Input          :en : 
*
* Output         : None
* Return         : ز
******************************************************************************/
uint16_t exp2_n(uint8_t en)
{
	switch(en)
	{
		case 0:  return 1;
		case 1:  return 2;
		case 2:  return 4;
		case 3:  return 8;
		case 4:  return 16;
		case 5:  return 32;
		case 6:  return 64;
		case 7:  return 128;
		case 8:  return 256;
		case 9:  return 512;
		case 10:  return 1024;
		case 11:  return 2048;
		case 12:  return 4096;
		case 13:  return 8192;
		case 14:  return 16384;
		case 15:  return 32768;
	}
	return 0xffff;
}

/*******************************************************************************
* Function Name  : GetAtr
* Description    :ȡICĸλӦźATR
* Input          :Buff : ATRĴBUFF
*
* Output         : None
* Return         : ز0x00ɹ
******************************************************************************/
int GetAtr(uint8_t *Buff)
{
	uint8_t   i/*,len*/,Flag,x;
	uint8_t   *Lenth_Point;
	//uint8_t   *ptr_atr;
	uint8_t   T,edc,TCK,CWI,BWI;
	uint16_t  N,j;
	uint8_t   Lenth=2;
	uint8_t  locData;

	edc=0;T=0;
	asyncard_info[current_slot].TA=0;
	asyncard_info[current_slot].TB=0;
	asyncard_info[current_slot].TC=0;
	asyncard_info[current_slot].TD=0;
	asyncard_info[current_slot].TS=0xff;
	//if(asyncard_info[current_slot].TS == 0xff)

	Lenth_Point=Buff;
	Parity_Check_Enable=0x00; //ڸλӦнֹżУط
	*Buff=0x00;

	//ʱʼ
	k_Ic_TotalTimeCount=0;//ÿʱ0
	k_IcMax_TotalTimeCount=0;
	k_total_timeover=0x00;

	k_IcMax_TimeCount = 0;
	k_IcMax_EtuCount = 116;		// 10.6msԼΪ114ETU
	USI_OpenWTC(k_IcMax_EtuCount);
	//¸ֽڵĵȴʱ䣬յ¸ֽڵʼλʱWTC
	k_IcMax_TimeCount = 0;
	k_IcMax_EtuCount = 9600+480+50;

	if((USART_TsReceive(&locData, SC_Receive_Timeout)) == SUCCESS)
	{
	}
	else
	{
		return(ICC_ATR_TIMEOUT);	// 1ce 054 20131217
	}

	SC_Slot_Active->SC_Convention = 0x00;
	/*As to 7816-3 protocol,TS must be 0x3B or 0x03*/
	if (locData==0x3B||locData==0x03)
	{
		/*ֽЭж*/
		if(locData==0x03)
		{
			SC_Slot_Active->SC_Convention=0x01;
			*(++Buff)=0x3F;
			g_USIReg->USICR1 |= 0x01; // У
		}
		else
		{
			*(++Buff)=locData;
			g_USIReg->USICR1 &= (~0x01); // żУ
		}
	}
	else
	{
		return ICC_ATR_TSERR;		// 20140102,TSӦµ
	}

	edc=0;
	//ptr_atr=Buff;

	k_IcMax_TotalTimeCount=1875;		//ʱTSʼλʼ,ȴʱ>19200+480 etu, 19200+4800 ETUµ磬1ETU=93us, 19200+480+480=1875ms	,ҪСֵ΢
//	k_IcMax_TotalTimeCount=1950;		//ʱTSʼλʼ,ȴʱ>19200+480 etu, 19200+4800 ETUµ磬1ETU=93us, 19200+480+480=1875ms	,ҪСֵ΢
//	k_IcMax_TotalTimeCount=1939;
	PIT2Open();		//ATRʱPITʱ

	if((USART_ByteReceive(&locData, SC_Receive_Timeout)) == SUCCESS)//T0
	{
		if(k_IccErrPar)
		{
			return ICC_PARERR;
		}
		*(++Buff) = locData;
	}
	else
	{
		return(ICC_ATR_TIMEOUT);
	}

	edc=edc^*Buff;
	Flag=*Buff;
	x=Flag&0x0f;
	i = 1;
	for(;;)
	{
		// TA
		if((Flag&0x10)==0x10)
		{
			if((USART_ByteReceive(&locData, SC_Receive_Timeout)) == SUCCESS)
			{
				if(k_IccErrPar)
				{
					return ICC_PARERR;
				}
				*(++Buff) = locData;
			}
			else
			{
				return(ICC_ATR_TIMEOUT);
			}

			if(i==1){
				asyncard_info[current_slot].TA1 = *Buff;
				asyncard_info[current_slot].TA|=0X01;
			}
			else if(i==2){
				asyncard_info[current_slot].TA2 = *Buff;
				asyncard_info[current_slot].TA|=0X02;
			}
			else if(i==3){
				asyncard_info[current_slot].TA3 = *Buff;
				asyncard_info[current_slot].TA|=0X04;
			}
			else    asyncard_info[current_slot].TA4 = *Buff;
			edc=edc^*Buff;
			Lenth++;
		}
		//TB
		if((Flag&0x20)==0x20)
		{
			if((USART_ByteReceive(&locData, SC_Receive_Timeout)) == SUCCESS)
			{
				if(k_IccErrPar)
				{
					return ICC_PARERR;
				}
				*(++Buff) = locData;
			}
			else
			{
				return(ICC_ATR_TIMEOUT);
			}

			if(i==1){
				asyncard_info[current_slot].TB1 = *Buff;
				asyncard_info[current_slot].TB|=0X01;
			}
			else if(i==2){
				asyncard_info[current_slot].TB2 = *Buff;
				asyncard_info[current_slot].TB|=0X02;
			}
			else if(i==3) {
				asyncard_info[current_slot].TB3 = *Buff;
				asyncard_info[current_slot].TB|=0X04;
			}
			else asyncard_info[current_slot].TB4 = *Buff;
			edc=edc^*Buff;
			Lenth++;
		}
		// TC
		if((Flag&0x40)==0x40)
		{
			if((USART_ByteReceive(&locData, SC_Receive_Timeout)) == SUCCESS)
			{
				if(k_IccErrPar)
				{
					return ICC_PARERR;
				}
				*(++Buff) = locData;
			}
			else
			{
				return(ICC_ATR_TIMEOUT);
			}

			if(i==1){
				asyncard_info[current_slot].TC1 = *Buff;
				asyncard_info[current_slot].TC|=0X01;
			}
			else if(i==2){
				asyncard_info[current_slot].TC2 = *Buff;
				asyncard_info[current_slot].TC|=0X02;
			}
			else if(i==3){
				asyncard_info[current_slot].TC3 = *Buff;
				asyncard_info[current_slot].TC|=0X04;
			}
			else asyncard_info[current_slot].TC4 = *Buff;
			edc=edc^*Buff;
			Lenth++;
		}
		//  no TD
		if((Flag&0x80)==0x00)
		{
			for(i=0;i<x;i++)		//ʷֽ
			{
				if((USART_ByteReceive(&locData, SC_Receive_Timeout)) == SUCCESS)
				{
					if(k_IccErrPar)
					{
						return ICC_PARERR;
					}
					*(++Buff) = locData;
				}
				else
				{
					return(ICC_ATR_TIMEOUT);
				}
				edc=edc^*Buff;
			}
			Lenth=Lenth+x;

			if(T)	//ΪT<>1Э鿨ƬһTCK
			{
				if((USART_ByteReceive(&locData, SC_Receive_Timeout)) == SUCCESS)
				{
					if(k_IccErrPar)
					{
						return ICC_PARERR;
					}
					*(++Buff) = locData;
				}
				else
				{
					return ICC_ATR_TIMEOUT;		//20131205,SC_DeInit̵̫VCCûб?
				}

				TCK=*Buff;
  			if(edc!=TCK)   return ICC_ATR_TCKERR;
				Lenth++;
			}
			*Lenth_Point=Lenth;

#ifndef ISO7816_PBOC_CARD		//ԷPBOCϸжԱݸATR
			//TA1
			if(asyncard_info[current_slot].TA & 0X01)
			{ 
				if (Get_FiDi(asyncard_info[current_slot].TA1, &asyncard_info[current_slot].F, &asyncard_info[current_slot].D) == FALSE)
				{
					return ICC_ATR_TA1ERR;
				}
			}
				
			//TC2  
			if((asyncard_info[current_slot].TC&0X02) == 0X00)
			{                    
				asyncard_info[current_slot].TC2=0x0a; 		//If TC2 is absent, then the default value is WI = 10.
			} 
			WWT=asyncard_info[current_slot].TC2*960;

			//TA3
			if(asyncard_info[current_slot].TA&0X04)
			{
				if(asyncard_info[current_slot].TA3==0xff) return ICC_ATR_TA3ERR;
			}
			else 
			{
				asyncard_info[current_slot].TA3=0x20; 
			}
			asyncard_info[current_slot].IFSC=asyncard_info[current_slot].TA3; 

			//TB3
			if(T==1)
			{  
				if((asyncard_info[current_slot].TB&0X04)==0X00) return ICC_ATR_TB3ERR; 
				CWI=asyncard_info[current_slot].TB3&0x0f; 
				CWT=11+exp2_n(CWI);
				WTX=0; 
				BWI=(asyncard_info[current_slot].TB3 >> 4)&0x0f; 
				BWT=11+960*exp2_n(BWI);
			} 
			

#else		//PBOC

			if(asyncard_info[current_slot].TA & 0X02)
			{
				if(asyncard_info[current_slot].TA2 & 0x10) 		//֧ĬϵĴ
					return ICC_ATR_TA2ERR;
			}
			// ֧TA1=11 '12'  '13'ֵATR
			if(asyncard_info[current_slot].TA & 0X01)
			{
#ifndef EMV_Co_Test
				///*////////PBOC 4.3a//////*/

				if((asyncard_info[current_slot].TA1 < 0x11) || (asyncard_info[current_slot].TA1 > 0x13))
				{
					return ICC_ATR_TA1ERR;
				}
#else
				///*////////EMV 4.3c for case 1702/1755//////*/

				if((asyncard_info[current_slot].TA1 != 0x11)
				&& (asyncard_info[current_slot].TA1 != 0x12)
				&& (asyncard_info[current_slot].TA1 != 0x13)
				&& (asyncard_info[current_slot].TA1 != 0x17)
				&& (asyncard_info[current_slot].TA1 != 0xD1)
				&& (asyncard_info[current_slot].TA1 != 0xD9))
				{
					return ICC_ATR_TA1ERR;
				}

#endif
			}
			if(!(asyncard_info[current_slot].TA & 0X02)) asyncard_info[current_slot].TA1 = 0x11;

			if(asyncard_info[current_slot].TA1==0x11)
				asyncard_info[current_slot].D=1;
			else if(asyncard_info[current_slot].TA1==0x12)
				asyncard_info[current_slot].D=2;
			else if(asyncard_info[current_slot].TA1==0x13)
				asyncard_info[current_slot].D=4;
			///*////////EMV 4.3c for case 1702//////*/
			else if(asyncard_info[current_slot].TA1==0x17)
				asyncard_info[current_slot].D=64;
			else if(asyncard_info[current_slot].TA1==0xD1)
				asyncard_info[current_slot].D=1;
			else if(asyncard_info[current_slot].TA1==0xD9)
				asyncard_info[current_slot].D=20;
			///*////////EMV 4.3c for case 1702 end//////*/
			else
			{
				asyncard_info[current_slot].TA1=0x11;
				asyncard_info[current_slot].D=1;
			}

			//  临λTB1ֵTB1=0ʱȸλ
			if(asyncard_info[current_slot].resetstatus==0x00)
			{
				if(((asyncard_info[current_slot].TB&0X01)==0X00)||(asyncard_info[current_slot].TB1!=0x00))
				{
				return ICC_ATR_TB1ERR;		// 1ce,064_01/03 20131218
				}
			}
			// ЧTDֵ
			if((asyncard_info[current_slot].TD&0X01)==0X01)
			{
				if((asyncard_info[current_slot].TD1 & 0x0f)>1)
				{
					return ICC_ATR_TD1ERR;
				}
				if(asyncard_info[current_slot].TD1 & 0x0f)
				{
					if((asyncard_info[current_slot].TD & 0X02)&&((asyncard_info[current_slot].TD2&0x0f)!=0x01))
					{
						return ICC_ATR_TD2ERR;
					}
				}
				else
				{
					if(((asyncard_info[current_slot].TD&0x02)==0x02)&&((asyncard_info[current_slot].TD2&0x0f)!=0x01)
					&&((asyncard_info[current_slot].TD2&0x0f)!=0x0e))
					{
						return ICC_ATR_TD2ERR;
					}
				}
			}
			// ЧTB2ֽ
			if(asyncard_info[current_slot].TB&0X02)
			{
				return ICC_ATR_TB2ERR;
			}

			//ЧTC2ֽ
			if(asyncard_info[current_slot].TC&0X02)
			{
				if(asyncard_info[current_slot].TC2!=0x0a)
				{
					return ICC_ATR_TC2ERR;
				}
			}
			asyncard_info[current_slot].TC2=0x0a;
			WWT=960*asyncard_info[current_slot].TC2;

			// ЧTA3ֽ
			if(asyncard_info[current_slot].TA&0X04)
			{
				if(asyncard_info[current_slot].TA3<0x10)
				{
					return ICC_ATR_TA3ERR;
				}
				if(asyncard_info[current_slot].TA3==0xff)
				{
					return ICC_ATR_TA3ERR;
				}
			}
			else
			{
				asyncard_info[current_slot].TA3=0x20;
			}
			asyncard_info[current_slot].IFSC=asyncard_info[current_slot].TA3;

			// ЧTB3ֽ
			if(T==1)
			{
				if((asyncard_info[current_slot].TB&0X04)==0X00)
				{
					return ICC_ATR_TB3ERR;
				}
				CWI=asyncard_info[current_slot].TB3&0x0f;
				if(CWI>5)
				{
					return ICC_ATR_TB3ERR;
				}
				CWT=11+exp2_n(CWI);
				WTX=0;
				BWI=(asyncard_info[current_slot].TB3 >> 4)&0x0f;
				if(BWI>4)
				{
					return ICC_ATR_TB3ERR;
				}
				BWT=11+960*exp2_n(BWI);

				if(asyncard_info[current_slot].TC1==0xff)
				{
					N=0;
				}
				else
				{
					N=asyncard_info[current_slot].TC1+1;
				}
				j=(uint16_t)exp2_n(CWI);
				if(j<=N)
				{
					return ICC_ATR_TB3ERR;
				}
			}

			// ЧTC3ֵ
			if(asyncard_info[current_slot].TC & 0X04)
			{
				if(asyncard_info[current_slot].TC3)
				{
					return ICC_ATR_TC3ERR;
				}
			}
#endif
			return ICC_SUCCESS;
		}
		if(Flag & 0x80){ //  TD1  TD2
			if((USART_ByteReceive(&locData, SC_Receive_Timeout)) == SUCCESS)
			{
				if(k_IccErrPar)
				{
					return ICC_PARERR;
				}
				*(++Buff) = locData;
			}
			else
			{
				return(ICC_ATR_TIMEOUT);
			}

			if(i==1){
				asyncard_info[current_slot].TD1=*Buff;
				asyncard_info[current_slot].TD|=0X01;
				T=*Buff&0x0f;
			}
			else if(i==2){
				asyncard_info[current_slot].TD2=*Buff;
				asyncard_info[current_slot].TD|=0X02;
				T|=*Buff&0x0f; // add 2002/04/23
			}
			else{
				asyncard_info[current_slot].TD3=*Buff;
				T|=*Buff&0x0f;
			}
			edc=edc^*Buff;
			Lenth++;
			Flag=*Buff;
		}
		i++;
	}
//	return ICC_SUCCESS;
}

/*******************************************************************************
* Function Name  : ClearAtr
* Description    :ATR BUF
* Input          :Channel : ҪATRbuf߼
*
* Output         : None
* Return         : None
******************************************************************************/
void ClearAtr(uint8_t Channel)
{
	asyncard_info[Channel].TA1 = 0x11;
	asyncard_info[Channel].D   = 0x01;
	asyncard_info[Channel].TA2 = 0x00;
	asyncard_info[Channel].TA3 = 0x00;
	asyncard_info[Channel].TA4 = 0x00;
	asyncard_info[Channel].TB1 = 0x00;
	asyncard_info[Channel].TB2 = 0x00;
	asyncard_info[Channel].TB3 = 0x00;
	asyncard_info[Channel].TB4 = 0x00;
	asyncard_info[Channel].TC1 = 0x00;
	asyncard_info[Channel].TC2 = 0x00;
	asyncard_info[Channel].TC3 = 0x00;
	asyncard_info[Channel].TC4 = 0x00;
	asyncard_info[Channel].TD1 = 0x00;
	asyncard_info[Channel].TD2 = 0x00;
	asyncard_info[Channel].TD3 = 0x00;
#ifndef ISO7816_PBOC_CARD
	asyncard_info[Channel].F = 372;
#endif
}

/*******************************************************************************
* Function Name  : IccSendCommand
* Description    :ֱT=1T=0Э齫CLA+INS+P1+P2+LCLE+INDATAݰʽ
*                  תӦĸʽICн״̬OUTDATA
*                 T=1ʱ OUTDATA LEN2+DATA+SW12
*                 T=0ʱ OUTDATA LEN2+DATA SW浽ȫֱ
* Input          :cla : CLA
*                 ins : INS
*                 p1  : P1
*                 p2  : P2
*                 p3  : P3
*                 indata:data
*                 le   :Le
*                 outdata:BUF
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int IccSendCommand(uint8_t cla, uint8_t ins,uint8_t p1,uint8_t p2,uint16_t p3,uint8_t *indata,uint16_t le,uint8_t *outdata)
{
	uint8_t test[5];
	uint8_t cmd_case;
	uint8_t inbuf[ICMAXBUF];     //
	uint8_t outbuf[ICMAXBUF];    //Ӧ
	uint8_t *ptr,len;
	int   result;
	uint16_t i;
	EMV_SW1=0xff;
	EMV_SW2=0xff;
	//T=1T=0ЭӦĴ
	switch(asyncard_info[current_slot].T)
	{
		case 1:            // T=1ʽ: cla ins p1 p2 lc data le
		{
			i=4;
			inbuf[2]=cla;
			inbuf[3]=ins;
			inbuf[4]=p1;
			inbuf[5]=p2;
			ptr=&inbuf[6];
			if((p3==0)&&(le==0))
			{
				i++;
				*ptr++=0;
			}
			if(p3>0)
			{
				len=(uint8_t)p3;
				i+=len+1;
				*ptr++=len;
				if(len>0)
				{
					memcpy(ptr,indata,len);
					ptr+=len;
				}
			}
			if(le>0)
			{
				if(le>=256)  le=0x00;
				i++;
				*ptr++=(uint8_t)le;
			}
			inbuf[0]=i/256;
			inbuf[1]=i%256;
			result=T1_send_command(0x00,inbuf,outbuf);
			if(result==0)
				memcpy(outdata,&outbuf[1],outbuf[1]*256+outbuf[2]+2);

			return result;
		}
		case 0:             //T=0ʽ: cla ins p1 p2 lc datacla ins p1 p2 le
		{
			cmd_case=0x01;
			if((p3==0)&&(le==0))  cmd_case=0x01;  // case 1 command
			if((p3==0)&&(le>0))   cmd_case=0x02;  // case 2 command
			if((p3>0)&&(le==0))   cmd_case=0x03;  // case 3 command
			if((p3>0)&&(le>0))    cmd_case=0x04;  // case 4 command
			test[0]=cmd_case;

			if(p3>0)		// ICP3ȵݣLEֽ
			{
				len=(uint8_t)p3;
				memcpy(inbuf,indata,p3);
			}
			else		 //ICLEݣֻLE
			{
				if(le>=256)  le=0x00;
				len=(uint8_t)le;
			}
			result=T0_send_command(cla,ins,p1,p2,len,inbuf,outbuf,test);

			if(result)   return result;
			memcpy(outdata,outbuf,outbuf[0]*256+outbuf[1]+2);
			EMV_SW1=test[0];
			EMV_SW2=test[1];
			return ICC_SUCCESS;
		}
		default:
			break;
	}
	return ICC_PROTOCALERR;
}

/*******************************************************************************
* Function Name  : T1_send_command
* Description    :T=1ЭµݷӦݡ
*                   ע: T1֧չָҪ֧Ҫ޸
* Input          :NAD : ַΪ0X00
*                 INBUF : ͵ϢֶLEN+INFINBUF[0]Ϊȣ
*                 OUTBUF: ӦݵԪʽNAD+LEN2ֽڣ+DATA+SW1+SW2
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int T1_send_command(uint8_t nad,uint8_t *inbuf,uint8_t *outbuf)
{
	uint8_t   sour[300],oldsour[300],respbuf[300],oldrblock[5] = {0};
	uint8_t   OLDIFSC;
	uint8_t   /*NAD,*/PCB/*,slotpcb*/,tmpch,tmpch1;
	uint16_t  len,len1/*,totallen,currentlen,remainlen*/;
	uint16_t  total_send_len,sent_len,remain_len;
	uint8_t   re_send_i_times,re_send_r_times;
//	uint16_t  i;
	int     result;

	OLDIFSC=asyncard_info[current_slot].IFSC;

start_t1_exchange:
	re_send_i_times=0;
	re_send_r_times=0;
	total_send_len=inbuf[0]*256+inbuf[1];
	remain_len=inbuf[0]*256+inbuf[1];
	sent_len=0;
	outbuf[0]=0x00;
	outbuf[1]=0x00;
	outbuf[2]=0x00;
	len=0;len1=0;
	asyncard_info[current_slot].sw1=0Xff;
	asyncard_info[current_slot].sw2=0xff;

send_remain_data:
	if(remain_len==0)
	{
		return ICC_ICCMESERR;
	}
	if(remain_len>asyncard_info[current_slot].IFSC)		// ݰifscʱ򽫰зֺٷ//
	{
		asyncard_info[current_slot].term_pcb|=0x20; //Iӷ//
		memcpy(&sour[3],&inbuf[2+sent_len],asyncard_info[current_slot].IFSC);
		sour[2] = asyncard_info[current_slot].IFSC;
	}
	else	//ֻһͿȫ //
	{
		asyncard_info[current_slot].term_pcb &= 0xdf;		//ȥӷ
		memcpy(&sour[3],&inbuf[2+sent_len],remain_len);
		sour[2]=remain_len;
	}
	sent_len+=sour[2]; // 趨ѷݳ  //
	remain_len=total_send_len-sent_len;
	sour[1]=asyncard_info[current_slot].term_pcb; // 趨ͰͷPCBЭֽ//
	sour[0]=0x00;		//nad
	memcpy(oldsour,sour,sour[2]+3); // ݷ͵I //
	asyncard_info[current_slot].term_pcb=sour[1] ^ 0x40;	//ն¸Ҫ͵I
	re_send_i_times=0;

re_send_i_block:
	if(re_send_i_times>2)		//3κοûӦµ
	{
		return ICC_T1_MOREERR;
	}
	re_send_i_times++;
	re_send_r_times=0;
	sour[0]=0x00;
	T1_Send_Block(sour);

receive_one_block:
	result=T1_Rece_Block(respbuf);

	if((result==ICC_T1_CWTERR)||(result==ICC_T1_BWTERR)||(result==ICC_T1_ABORTERR))
	{
		//ʱִµR
		return result;
	}

	if((result==ICC_T1_PARITYERR)||(result==ICC_T1_EDCERR))
	{
		if(re_send_r_times!=0)		//һRطR,test case 1778/1784 20140521
		{
			//һRҽտЧʱ,R鱻ط
			sour[0] = oldrblock[0];
			sour[1] = oldrblock[1];
			sour[2] = oldrblock[2];
			//re_send_r_times = 0;
		}
		else
		{
			// 1.һIҽտЧͷһR,RN(R)ʹԤڵIN(S)=N(R)
			// 2.һS(...Ӧ)ҽյĿЧʱ,ͷһR
			tmpch = asyncard_info[current_slot].card_pcb^0x40;	//ΪڽտƬI˳ţΪϴνյ¸ţ//
			sour[1]=((tmpch >> 2) & 0x10) | 0x81; // ż/EDC
			sour[2]=0;
		}
		goto re_send_r_block;
	}
	if(result==ICC_T1_INVALIDBLOCK)
	{
		if(re_send_r_times!=0)		//һRطR,test case 1778/1784 20140521
		{
			//һRҽտЧʱ,R鱻ط
			sour[0] = oldrblock[0];
			sour[1] = oldrblock[1];
			sour[2] = oldrblock[2];
			//re_send_r_times = 0;
			goto re_send_r_block;
		}
		else
		{
			// 1.һIҽտЧͷһR,RN(R)ʹԤڵIN(S)=N(R)
			// 2.һS(...Ӧ)ҽյĿЧʱ,ͷһR
			goto set_rblock_with_othererr;
		}
	}

	PCB=respbuf[1]; // ȡӦݰͷ
	//I
	if((PCB&0X80)==0X00)
	{
		if(remain_len>0) 		//ʣӦյI
		{
			if(re_send_r_times!=0)		// 20140520
			{
				//һRҽտЧʱ,R鱻ط
				sour[0] = oldrblock[0];
				sour[1] = oldrblock[1];
				sour[2] = oldrblock[2];
				//re_send_r_times = 0;
				goto re_send_r_block;
			}
			else
			{
				// 1.һIҽտЧͷһR,RN(R)ʹԤڵIN(S)=N(R)
				// 2.һS(...Ӧ)ҽյĿЧʱ,ͷһR
				goto set_rblock_with_othererr;
			}
		}

		//  յIкŲͬǰյIк  ʱȷϽȷյݵOUTBUFС
		if((PCB & 0x40) != (asyncard_info[current_slot].card_pcb & 0x40))
		{
			re_send_r_times=0;
			if(respbuf[2]>0)		//ݳȲΪ򱣴
			{
				len1 = outbuf[1] * 256 + outbuf[2];
				len=len1 + respbuf[2];
				outbuf[1]= len / 256;
				outbuf[2]= len % 256;
				memcpy(&outbuf[len1+3],&respbuf[3],respbuf[2]);
			}
			asyncard_info[current_slot].card_pcb=PCB;		//óɸյк

			if((PCB&0X20)==0X20)		// յI
			{
				tmpch = asyncard_info[current_slot].card_pcb ^ 0x40;		// ó¸I_Block˳
				sour[1]=((tmpch >>2 ) & 0x10) | 0x80;
				sour[2]=0;
				goto re_send_r_block;
			}
			// ȷյӵI˳
			result=ICC_SUCCESS;
			goto end_t1_exchange;
		}
		else 		//кŴ
		{
			if(re_send_r_times!=0)		// 20140520
			{
				//һRҽտЧʱ,R鱻ط
				sour[0] = oldrblock[0];
				sour[1] = oldrblock[1];
				sour[2] = oldrblock[2];
				//re_send_r_times = 0;
				goto re_send_r_block;
			}
			else
			{
				// 1.һIҽտЧͷһR,RN(R)ʹԤڵIN(S)=N(R)
				// 2.һS(...Ӧ)ҽյĿЧʱ,ͷһR
				goto set_rblock_with_othererr;
			}
		}
	}
	//R
	else if((PCB&0XC0)==0X80)
	{
		tmpch=asyncard_info[current_slot].term_pcb;
		if((tmpch&0x40)==((PCB&0x10)<<2))		// յŵն¸Ҫ͵IűICһӿ
		{
			if((PCB&0xef)==0x80)		// r-block޴Ϣ
			{
				if((oldsour[1]&0x20)==0x20) // ն˸շ͵Iӱʶ
				{
					goto send_remain_data;
				}
				else 	//ն  
				{

					if(re_send_r_times!=0)		// 20140520
					{
						//һRҽտЧʱ,R鱻ط
						sour[0] = oldrblock[0];
						sour[1] = oldrblock[1];
						sour[2] = oldrblock[2];
						//re_send_r_times = 0;
						goto re_send_r_block;
					}
					else
					{
						//ЧĿطкһյIкţն˳ʼIΪ0յIҲΪ0
						tmpch = asyncard_info[current_slot].card_pcb ^ 0x40;
						tmpch1=((tmpch >> 2 ) & 0x10) | 0x82;  	//Ĵ

						re_send_r_times=0;
						sour[1]=tmpch1;
						sour[2]=0;
						goto re_send_r_block;
					}
				}
			}
			else 		// дʶR
			{
				if(re_send_r_times!=0)		 // طR
				{
					//sour[1]=sour[1]&0xf0;		//test case 1772/1809 20140521
					//һRҽտЧʱ,R鱻ط
					sour[0] = oldrblock[0];
					sour[1] = oldrblock[1];
					sour[2] = oldrblock[2];
					re_send_r_times = 0;			//test case 1774 20140523
					goto re_send_r_block;
				}
				else		// һR
				{
					/*tmpch = asyncard_info[current_slot].card_pcb ^ 0x40;
					sour[1]=((tmpch >>2 ) & 0x10) | 0x80;
					sour[2]=0;
					goto re_send_r_block; */
					goto set_rblock_with_othererr;		// test case 1771, 20140521
				}
			}

		}

		if((tmpch&0x40)!=((PCB&0X10)<<2))		// ŵնѷ͵IطI
		{
			if((asyncard_info[current_slot].card_pcb&0x20)==0x20) 		//b6̶Ϊ0
			{
				goto re_send_r_block;
			}

			if(OLDIFSC!=asyncard_info[current_slot].IFSC)
			{
				//յµIFSCЭ̺յRطʱ
				//ȻָնIкţͷ
				OLDIFSC=asyncard_info[current_slot].IFSC;
				asyncard_info[current_slot].term_pcb=oldsour[1];
				goto start_t1_exchange;
			}
			memcpy(sour,oldsour,oldsour[2]+3);
			goto re_send_i_block;
		}
		// طR
		//goto re_send_r_block;
	}
	//S
	else if((PCB&0XC0)==0XC0)
	{
		if((PCB & 0x20)==0X00)		//յIC͵Sź/
		{
			//յIC͵źݴ
			//޸Ӧ趨SӦIC
			sour[1]=0x20 | respbuf[1] ;
			sour[2]=respbuf[2];
			memcpy(&sour[3],&respbuf[3],sour[2]);
			if((respbuf[1] & 0x1f) ==0x03)		// BWT  BWT=BWT * respbuf[3];
			{
				WTX= respbuf[3];
			}
			else if ((respbuf[1] & 0x1f) == 0x01)		 //Ϣֶ
			{
				asyncard_info[current_slot].IFSC = respbuf[3];
			}
			else if((respbuf[1]&0x1f)==0x00)		 // ͬ
			{
			}
			sour[0]=0x00;  //SӦIC
			T1_Send_Block(sour);
			re_send_r_times=0;
			goto receive_one_block;
		}
		else 		//յIC͵SӦź/
		{
		/*
			if((sour[1]&0xe0)==0xc0)
			{
				// ն˷ϢʱӦӦĲ
				re_send_r_times=0;
				if ((respbuf[1] & 0x1f) == 0x01)		//ifsd response
				{
					asyncard_info[current_slot].IFSD = respbuf[3];
				}
				else if((respbuf[1] & 0x1f) ==0x00)	//ͬӦ
				{    //  Reset or deactivation
					asyncard_info[current_slot].term_pcb=0x00;
					asyncard_info[current_slot].card_pcb=0x40;
					goto start_t1_exchange;
				}
				goto end_t1_exchange;
			}
		*/
			if(re_send_r_times!=0)		// test case 1778, 20140521
			{
				//һRҽտЧʱ,R鱻ط
				sour[0] = oldrblock[0];
				sour[1] = oldrblock[1];
				sour[2] = oldrblock[2];
				//re_send_r_times = 0;
				goto re_send_r_block;
			}
		}
	}

set_rblock_with_othererr:
	tmpch = asyncard_info[current_slot].card_pcb ^ 0x40;
	sour[1]=((tmpch >>2 ) & 0x10) | 0x82; // R
	sour[2]=0;

re_send_r_block:
	if(re_send_r_times!=0)
	{
		if((oldrblock[0]!=sour[0])||(oldrblock[1]!=sour[1])||(oldrblock[2]!=sour[2]))
			re_send_r_times=0;
	}
	if(re_send_r_times==0)
	{
		oldrblock[0]=sour[0];
		oldrblock[1]=sour[1];
		oldrblock[2]=sour[2];
	}
	if(re_send_r_times>1)
	{
		return ICC_T1_MOREERR;
	}
	T1_Send_Block(sour);
	re_send_r_times++;
	goto receive_one_block;

end_t1_exchange:
	if(result!=0)
	{
		//ͨ봦ʧܣSW1 SW2Ϊ0XFF
		asyncard_info[current_slot].sw1=0Xff;
		asyncard_info[current_slot].sw2=0xff;
		return result;
	}
	len=outbuf[1]*256+outbuf[2]+3;
	// յλݱ浽SW1SW2
	asyncard_info[current_slot].sw1=outbuf[len-2];
	asyncard_info[current_slot].sw2=outbuf[len-1];
	return ICC_SUCCESS;
}

/*******************************************************************************
* Function Name  : T0_send_command
* Description    :T=0Э·ͷCLA+INS+P1+P2+P3ݰDATABUFȡICӦݣOUTBUF״ֽ̬ڣRSLT
* Input          :Class : CLA
*                 Ins : INS
*                 p1  : P1
*                 p2  : P2
*                 p3  : P3
*                 databufն˷ݰ䳤ΪP3
*                 outbuf:ICݣ[0]Ϊݳȣ
*                 relt:CASEţ1234
* Output         : None
* Return         : ִн0x00ɹ  ʧ       ʱSW1SW2״ֽ̬ڡ
******************************************************************************/
int T0_send_command(uint8_t cla,uint8_t ins,uint8_t p1,uint8_t p2,uint8_t p3, uint8_t *databuf,uint8_t *outbuf,uint8_t *rslt)
{
	uint16_t  len,i,len1,len2/*,Tc2*/;
	uint8_t   ret;
	uint8_t   tempsw1,tempsw2;
	uint8_t   *ptr1,*ptr2,status[2],cmdbuf[5];
	uint8_t   cmd_case,cardtype,auto_resp,is_rece_send;
	uint8_t   Change_Status_Word;
#ifdef EMV_Co_Test
	uint8_t   GetIns = 0;
#endif
	uint16_t  /*NS,*/NR/*, temp*/;
	uint8_t   first_error_status = 0;

	NR=16+2;                 // 򱣻ʱ,2etu
	cmd_case=*rslt;        // CASE 1234//
	cardtype = asyncard_info[current_slot].autoresp;			//ǷԶGetResponse
	if(cardtype)           // ԶӦ־ //
		auto_resp=0x00;   // Զ //
	else
		auto_resp=0x01;   // Զ//
	Change_Status_Word=0;  // ·״ֽ̬ڱ־1- //

	//ʱʼ
	k_Ic_TotalTimeCount=0;//ÿʱ0
	k_IcMax_TotalTimeCount=0;
	k_total_timeover=0x00;

	//ʹWTCʱַȴʱ
	k_IcMax_TimeCount = 0;
	k_IcMax_EtuCount = (WWT+480+50)*(asyncard_info[current_slot].D);
	USI_OpenWTC(k_IcMax_EtuCount);

	is_rece_send=0;        //ǰݰ״̬0=գ1=
	if(cmd_case==0x01) is_rece_send=0;
	else if(cmd_case==0x02) is_rece_send=0;
	else if(cmd_case==0x03) is_rece_send=1;
	else is_rece_send=1;

	//ͷ //
	cmdbuf[0]=cla;
	cmdbuf[1]=ins;
	cmdbuf[2]=p1;
	cmdbuf[3]=p2;
	cmdbuf[4]=p3;
	status[0]=0xff;
	status[1]=0xff;
	len=0;
	ptr1=databuf;
	ptr2=outbuf+2;
	tempsw1=0xff;
	tempsw2=0xff;

	while(1)
	{
flg1:
		len1=(uint16_t)cmdbuf[4];  // ݳ
		len2=(uint16_t)cmdbuf[4];  // Ӧݳ
		if (len2 == 0)		// le=0ʱָ25620140525
		{
			len2 = 256;
		}

		DelayNETU(NR);		//򱣻ʱ
		for(i=0;i<5;i++)
		{
			ret=SC_PutByte(cmdbuf[i]);		//CLA INS P1 P2 P3
#if 0
   			printf ("%x",cmdbuf[i]);
#endif
			if(ret)
			{
				return ICC_T0_MORESENDERR;
			}
		}

flg2:
		//ȡһֽ
		if(SC_GetByte(&status[0]) == ERROR)		//෴򣬼ն˷IC
		{
#if 0
   			printf ("%x",status[0]);
#endif

			return ICC_T0_TIMEOUT;			//ʱطʧܺ󶼻ᵽ
		}

		// ֽڵINS----ͻݰ  //
		if(status[0]==cmdbuf[1])
		{
#ifdef EMV_Co_Test
			GetIns = 1;
#endif
			if(is_rece_send) 		//Lc
			{
				DelayNETU(NR);		//򱣻ʱ
				for(i=0;i<len1;len1--)
				{
					ret=SC_PutByte(*ptr1);
					if(ret)
					{
						return ICC_T0_MORESENDERR;
					}
					ptr1++;
				}

				goto flg2;  // ȴһֽ //
			}
			else		// Le
			{
				len+=len2;
				if(len>256)
				{
					return ICC_DATA_LENTHERR;
				}
				for(i=0;i<len2;len2--)
				{
					if(SC_GetByte(ptr2) == ERROR)
					{
						return ICC_T0_TIMEOUT;			//ʱطʧܺ󶼻ᵽ
					}
					ptr2++;
				}
				goto flg2;
			}
		}

		// INSĲ  ջһ  //
		else if(status[0]==(uint8_t)(~cmdbuf[1]))
		{
#ifdef EMV_Co_Test
			GetIns = 1;
#endif
			if(is_rece_send)		//Lc
			{
				DelayNETU(NR);		//򱣻ʱ
				ret=SC_PutByte(*ptr1);
				if(ret){
					return ICC_T0_MORESENDERR;
				}
				ptr1++;
				len1--;
				goto flg2;
			}
			else 		//Le
			{
				if(SC_GetByte(ptr2) == ERROR)
				{
					return ICC_T0_TIMEOUT;			//ʱطʧܺ󶼻ᵽ
				}

				ptr2++;len++;
				len2--;
				if(len>256){
					return ICC_DATA_LENTHERR;
				}
				goto flg2;
			}
		}
		else if(status[0]==0x60)
		{ //  նṩӵĹȴʱ  //
			goto flg2;
		}
#ifdef EMV_Co_Test
		else
		{
			if(cmd_case != 4)
			{
				GetIns = 1;
			}
		}
#endif
		if(((status[0]&0xf0)!=0X60)&&((status[0]&0xf0)!=0x90))		//sw1
		{  //յĹ̻״ֽ̬ںͷŴ
			return ICC_T0_INVALIDSW;
		}
		// SW1Ϊ6X9X60⣩ʱȴù̵һ״ֽ̬SW2
		if(SC_GetByte(&status[1]) == ERROR)
		{
			return ICC_T0_TIMEOUT;			//ʱطʧܺ󶼻ᵽ
		}
#ifdef EMV_Co_Test
		/*ûյINSǰյSWôֱӷ״̬*/
		if(auto_resp && GetIns) 		//ԶӦ  //
		{
			GetIns = 0;
#else
		if(auto_resp) 		//ԶӦ  //
		{
#endif
			if(status[0]==0x61)
			{    // SW1=0X61նͳһGET RESPONSEͷ
				// ICеP3=SW2 //
				cmdbuf[0]=0x00;cmdbuf[1]=0xc0;cmdbuf[2]=0x00;
				cmdbuf[3]=0x00;cmdbuf[4]=status[1];
				is_rece_send=0;  // ĲֻܴICݰ//
				if(cmd_case==0x04) cmd_case=0x02;
				goto flg1;       // ¸ͷ
			}
			if(status[0]==0x6c)
			{    // SW1=0X6Cն˴ǰͷIC
				// P3=SW2 //
				cmdbuf[4]=status[1];
				is_rece_send=0;
				if(cmd_case==0x04) cmd_case=0x02;
				goto flg1;
			}
			if(cmd_case==0x04)//&&(FirstByte_Is_Status==0))
			{
				if (first_error_status==0)
				{
					if (status[0]==0x62 && status[1]==0x81)
					{
						first_error_status = 1;		// test case 1744(x=3) 20140524
						goto flg1;		//ط
					}
					if((status[0]==0x62)||(status[0]==0x63)||
						(((status[0]&0xf0)==0x90) && (!(status[0]==0x90 && status[1]==0x00))))   	// sw = 6283/6335/9FFF
					{
						cmdbuf[0]=0x00;cmdbuf[1]=0xc0;cmdbuf[2]=0x00;
						cmdbuf[3]=0x00;cmdbuf[4]=0x00;
						is_rece_send=0;
						Change_Status_Word=1;
						cmd_case=0x02; //޸CASE״ֹ̬ط //
						tempsw1=status[0];
						tempsw2=status[1];
						goto flg1;
					}
				}
				else
				{
					if (status[0]==0x9F && status[1]==0xFF)
					{
						//˳
					}
					else
					{
						goto flg1;		//ط
					}
				}
			}

		}
		// յݵĹֽʱ򱣴״ֽ̬ڲ
		if(Change_Status_Word)
		{
			*rslt=tempsw1;
			*(rslt+1)=tempsw2;//status[1];//
		}
		else
		{
			*rslt=status[0];
			*(rslt+1)=status[1];
		}
		*outbuf=len/256;
		*(outbuf+1)=len%256; // յݳ //
		return ICC_SUCCESS;
	}
//	return ICC_SUCCESS;
}

/*******************************************************************************
* Function Name  : T1_IFSD_command
* Description    :յȷĸλӦ󣬶T=1Ƭ뷢һIFSDָʾնȡ鳤ȡ
* Input          :slot : ߼
*
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int  T1_IFSD_command(uint8_t slot)
{
	int   ret;
	uint8_t ifsdbuf[10],respbuf[300];
	uint8_t resendtimes=0;
//	uint8_t tmpch;

	if(asyncard_info[slot].T==0)
	{
		return ICC_SUCCESS;
	}
	ifsdbuf[0]=0x00;
	ifsdbuf[1]=0xc1;
	ifsdbuf[2]=0x01;
	ifsdbuf[3]=0xfe;
	ifsdbuf[4]=0x00; //0-3 Уֵ

	while(1)
	{
		if(resendtimes<3)
		{
			ret=T1_Send_Block(ifsdbuf);
		}
		else
		{
			return ICC_T1_IFSDERR;
		}
		resendtimes++;
		ret=T1_Rece_Block(respbuf);
		if((ret==ICC_T1_CWTERR)||(ret==ICC_T1_BWTERR)||(ret==ICC_T1_ABORTERR))
		{
			return ret;
		}

		//һS(...)ҽյӦS(...Ӧ)(IFD)ʱ,S(...)ط
		if((ret==ICC_T1_PARITYERR)||(ret==ICC_T1_EDCERR)||(ret==ICC_T1_INVALIDBLOCK))
			continue;
		if(((respbuf[1]&0xe0)!=0xe0)||((respbuf[1]&0x0f)!=0x01))		//ֵΪ00E101FE1E
			continue;
		if((respbuf[2]!=0x01)||(respbuf[3]!=0xfe))
			continue;

		asyncard_info[slot].IFSD=254;
		return ICC_SUCCESS;
	}
//	return ICC_SUCCESS;
}

/*******************************************************************************
* Function Name  : T1_Send_Block
* Description    :T=1Э·һ
* Input          :Inbuf : buf
*
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int  T1_Send_Block(uint8_t *Inbuf)
{
	uint8_t   edc;
	uint16_t  i,len;
	uint16_t  NR;

	NR=22+200;		//200etu, Test case 1767_2x 20140530

	len=*(Inbuf+2)+3;   //  ܳNAD+PCB+LEN+LENDATA
	edc=0;              //  ԪУEDC

	DelayNETU(NR);//ͱʱ
	for(i=0;i<len;i++)
	{
		SC_PutByte(Inbuf[i]);
		edc=edc ^ Inbuf[i];
	}
	SC_PutByte(edc);

	//T1Ľն⵽żУźţԷͶ˲⵽źţֱӷسɹ
	return ICC_SUCCESS;
}

/*******************************************************************************
* Function Name  : T1_Rece_Block
* Description    :T=1Э½һ
* Input          :Outbuf : ݻbuf
*
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int  T1_Rece_Block(uint8_t *Outbuf)
{
	uint8_t   i,ch,edc;
	uint8_t   Parity_Error_Flag;
//	uint32_t  T1BWT,T1CWT;
	uint8_t   r_nad,r_pcb,r_len,r_inf;
	uint8_t   r_len_temp;

	k_IcMax_TotalTimeCount=0x00;
	k_Ic_TotalTimeCount=0x00;
	k_total_timeover=0x00;

	if (WTX!=0)	//ICշWTX
	{
		//ʹWTCʱַȴʱ
		k_IcMax_TimeCount = 0;
		k_IcMax_EtuCount = ((BWT-11)*(asyncard_info[current_slot].D)+11)*WTX+(960+50)*(asyncard_info[current_slot].D)*WTX;		//BWT*n+D*960*n
		USI_OpenWTC(k_IcMax_EtuCount);

		WTX=0;
	}
	else
	{
		k_IcMax_TimeCount = 0;
		k_IcMax_EtuCount = ((BWT-11)+960+50)*(asyncard_info[current_slot].D)+11;
		USI_OpenWTC(k_IcMax_EtuCount);
	}

		//¸ֽڵĵȴʱ䣬յ¸ֽڵʼλʱWTC
		k_IcMax_TimeCount = 0;
		k_IcMax_EtuCount = CWT+4+1;		//CWT+4<ն˷Χ<CWT+4+2

	edc=0;
	Parity_Error_Flag=0;
	if(SC_GetByte(&ch) == ERROR)		//NAD
	{
		return ICC_T1_BWTERR;
	}

	if(k_IccErrPar) Parity_Error_Flag=0x01;//
	edc=edc ^ ch;
	*Outbuf++=ch;
	r_nad=ch;

	if(SC_GetByte(&ch) == ERROR)		//PCB
	{
		return ICC_T1_CWTERR;
	}
	if(k_IccErrPar) Parity_Error_Flag=0x01;//
	edc=edc ^ ch;
	*Outbuf++=ch;
	r_pcb=ch;

	if(SC_GetByte(&ch) == ERROR)		//ȡ
	{
		return ICC_T1_CWTERR;
	}
	if(k_IccErrPar) 			// 20131218 1CF 086.00/02Ӧַµ
	{
		//T1ʱżУҲܻȡȷ
		Parity_Error_Flag=0x01;//
	}
	edc=edc ^ ch;
	*Outbuf++=ch;
	r_len=ch;
	r_len_temp=ch;
	if((r_pcb&0xc0)==0x80) 		// R
	{
	//if(ch) r_len_temp=0;		// 1CF 087.01 20131219
	}
	else if((r_pcb&0xc0)==0xc0)		//S
	{
	//if(ch>1) r_len_temp=1;		//  1CF 087.01 20131219
	}

	for(i=0;i<r_len_temp;i++)
	{
		if(SC_GetByte(&ch) == ERROR)
		{
			return ICC_T1_CWTERR;
		}
		if(k_IccErrPar) Parity_Error_Flag=0x01;
		edc=edc ^ ch;
		*Outbuf++=ch;
	}
	r_inf=ch;		//SϢֻ1ֽ
	if(SC_GetByte(&ch) == ERROR)		//EDC
	{
		if(((r_pcb&0x80)==0)&&(r_len==0xff)){ 		//IĳΪFF
			//           return ICC_T1_INVALIDBLOCK;		//R,20131220
			return ICC_T1_ABORTERR;		//µ,20131220
		}
		return ICC_T1_CWTERR;
	}
	if(k_IccErrPar) Parity_Error_Flag=0x01;//
	*Outbuf=ch;
	if(ch!=edc) return ICC_T1_EDCERR;
	if(Parity_Error_Flag) return ICC_T1_PARITYERR;
	if(r_nad) return ICC_T1_INVALIDBLOCK;   //nad!=0

	// I_BLOCK
	if((r_pcb&0x80)==0)
	{
		if(r_len==0xff) 	//IϢ򳤶ΪFF
		{
#if 0      //R    	,20131220
			for (i=0; i<120; i++)		// 12etu*10
			{
			delay1ETU();	// 20131219, 1CF 089.02, 1CF 096.01 ܻᷢͳ255ֽڵݣʵδգICCٷR
			if ((i%12) == 0)		// 20131219, 1CF 092.02/ 1CF 094.06/ 1CF 098.01 建,ÿֽһ
			{
			test = USIRDR;		//ᵼ1CF087.02?20131219
			}
			}
			return ICC_T1_INVALIDBLOCK;
#else	//µ,20131220
			/*
			for (i=0; i<120; i++)		// 12etu*10
			{
			delay1ETU();	// 20131219, 1CF 089.02, 1CF 096.01 ܻᷢͳ255ֽڵݣʵδգICCµ
			}
			*/
			return ICC_T1_ABORTERR;
#endif
		}
	}
	// R_BLOCK
	else if((r_pcb&0xc0)==0x80)
	{
		if(r_len) return ICC_T1_INVALIDBLOCK;		//rϢ򳤶ȲΪ0
		if((r_pcb&0x20)==0x20) return ICC_T1_INVALIDBLOCK;  	//b6̶Ϊ0
	}
	// S_BLOCK
	else
	{
		if(r_pcb==0xc1){ // ifs request
			if((r_inf<0x10)||(r_inf>0xfe)) return ICC_T1_INVALIDBLOCK;
		}
		else if(r_pcb==0xc2)  return ICC_T1_ABORTERR;	// abort request
		else if(r_pcb==0xe3) return ICC_T1_INVALIDBLOCK; //S(WTX response)
		else if(r_pcb==0xe2) return ICC_T1_INVALIDBLOCK; //S(ABORT response)
		else if(r_pcb==0xe0) return ICC_T1_INVALIDBLOCK; //S(RESYNCH response)
		if(r_len!=1) return ICC_T1_INVALIDBLOCK;   	//sϢ򳤶ȲΪ1
		if((r_pcb&0x1f)>4) return ICC_T1_INVALIDBLOCK; 	//s
	}
	return ICC_SUCCESS;
}
