#include "type.h"
#include "ioctrl_drv.h"

void SWD_Enable_Cmd(bool index)
{
	if(index == TRUE)
	{
				IOCTRL->SWAP_CONTROL_REG |= (1<<1);       //GPIO disable
	}
	else
	{
				IOCTRL->SWAP_CONTROL_REG &= ~(1<<1);      //GPIO enable  
	}
}

/*******************************************************************************
* Function Name  :IO_Ctrl_SCI_Swap
* Description    :SCI GINT ùл
* Input          :-sg_sel   ѡ
*									-sw 			:ùܿ
*									 TRUE  :ܴ
*                  FALSE :ܹر
*
* Output         : None
* Return         : None
******************************************************************************/
void IO_Ctrl_SCI_Swap(IOCTRL_SG_SEL sg_sel, bool sw)
{
	if(TRUE == sw)//on
	{
		switch(sg_sel)
		{
			case TX1_GINT4:
				IOCTRL->SCI_CONTROL_REG |= SCICR_TX1_GINT4_SWAP_MASK;	//GINT4RX1ù
				break;
			case RX1_GINT0:
				IOCTRL->SCI_CONTROL_REG |= SCICR_RX1_GINT0_SWAP_MASK;	//GINT0TX1ù
				break;
			case TX2_GINT5:
				IOCTRL->SCI_CONTROL_REG |= SCICR_TX2_GINT5_SWAP_MASK;	//GINT5RX2ù
				break;
			case RX2_GINT3:
				IOCTRL->SCI_CONTROL_REG |= SCICR_RX2_GINT3_SWAP_MASK;	//GINT3RX2ù
				break;
			case TX3_GINT1:
				IOCTRL->SCI_CONTROL_REG |= SCICR_TX3_GINT1_SWAP_MASK;	//GINT1TX3ù
				break;
			case RX3_GINT2:
				IOCTRL->SCI_CONTROL_REG |= SCICR_RX3_GINT2_SWAP_MASK;	//GINT2TX3ù
				break;
			default:
				break;
		}
	}
	else	//off
	{
		switch(sg_sel)
		{
			case TX1_GINT4:
				IOCTRL->SCI_CONTROL_REG &= ~SCICR_TX1_GINT4_SWAP_MASK;	//رGINT4RX1ù
				break;
			case RX1_GINT0:
				IOCTRL->SCI_CONTROL_REG &= ~SCICR_RX1_GINT0_SWAP_MASK;	//رGINT0TX1ù
				break;
			case TX2_GINT5:
				IOCTRL->SCI_CONTROL_REG &= ~SCICR_TX2_GINT5_SWAP_MASK;	//رGINT5RX2ù
				break;
			case RX2_GINT3:
				IOCTRL->SCI_CONTROL_REG &= ~SCICR_RX2_GINT3_SWAP_MASK;	//رGINT3RX2ù
				break;
			case TX3_GINT1:
				IOCTRL->SCI_CONTROL_REG &= ~SCICR_TX3_GINT1_SWAP_MASK;	//رGINT1TX3ù
				break;
			case RX3_GINT2:
				IOCTRL->SCI_CONTROL_REG &= ~SCICR_RX3_GINT2_SWAP_MASK;	//رGINT2TX3ù
				break;
			default:
				break;
		}
	}

}


