/************************************************************************
  * Copyright(c) 2023 Levetop Semiconductor Co.,Led. All rights reserved.
  * @file     tp_iic.h
  * @author   UartTFT Application Team
  * @version  V0.0.1
  * @date     2023-01-01
  * @brief     
 *************************************************************************/

#ifndef _TP_IIC_H
#define _TP_IIC_H

#include <stdint.h>

// IO IIC
uint8_t CTI2C_Start(void);
uint8_t CTI2C_Stop(void);
uint8_t CTI2C_write_byte(const uint8_t s);
uint8_t CTI2C_read_byte(uint8_t ack);

#endif /* _TP_IIC_H */
