
#ifndef __IOCTRL_REG_H__
#define __IOCTRL_REG_H__
#include "type.h"

typedef struct
{
	__IO uint32_t SPI_CONTROL_REG;	 					//0x00
	__IO uint32_t USI_CONTROL_REG;   					//0x04
	__IO uint32_t I2C_CONTROL_REG;   					//0x08
	__IO uint32_t SCI_CONTROL_REG;   					//0x0c
	__IO uint32_t GINTL_CONTROL_REG;  				//0x10
	__IO uint32_t GINTH_CONTROL_REG;  				//0x14
	__IO uint32_t RESERVED1;   								//0x18
	__IO uint32_t SWAP_CONTROL_REG;   				//0x1C
	__IO uint32_t SPIM1_CONTROL_REG;  				//0x20
	__IO uint32_t SPIM2_CONTROL_REG;  				//0x24
	__IO uint32_t	RESERVED2;									//0x28
	__IO uint32_t GINT_31_30_CONTROL_REG;			//0x2c
	__IO uint32_t	RESERVED3;									//0x30
	__IO uint32_t	RESERVED4;									//0x34
	__IO uint32_t	GINT_39_32_CONTROL_REG;			//0x38
	__IO uint32_t	GINT_29_22_CONTROL_REG;			//0x3c
	__IO uint32_t	RESERVED5;									//0x40
	__IO uint32_t CLKOUT_RSTOUT_CONTROL_REG;	//0x44
	__IO uint32_t	RESERVED6;									//0x48
	__IO uint32_t	RESERVED7;									//0x4c
	__IO uint32_t	RESERVED8;									//0x50
}IOCTRL_TypeDef;


#endif


