// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : trng_drv.c
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include "cpm_drv.h"
#include "trng_drv.h"

/*******************************************************************************
* Function Name  : Init_Trng
* Description    : ܳʼ
*                  ģʱӣģʱƵΪϵͳʱƵʵ1/8
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Init_Trng(void)
{
	CPM->CPM_IPSCGTCR |= TRNG_ENABLE;

	//ϵͳʱӵ60Ƶ
	rTRNGIF_CTRL = 59;
	rTRNGIF_CTRL |= TRNGIF_CTRL_EN_MASK;

	rTRNGIF_CTRL |= (0xFF << 16);
}

/*******************************************************************************
* Function Name  : Trng_Disable
* Description    : رģʱ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Trng_Disable(void)
{
	CPM->CPM_IPSCGTCR &= ~(TRNG_ENABLE);
}

/*******************************************************************************
* Function Name  : GetRandomWord
* Description    : ɺ
* Input          : None
* Output         : None
* Return         : 1uint32_t
******************************************************************************/
uint32_t GetRandomWord(void)
{
	uint32_t random_value, tmp;

	tmp = rTRNGIF_CTRL;

	while(!(tmp & TRNGIF_CTRL_STA_MASK))
	{
		tmp = rTRNGIF_CTRL;
	}

	random_value = rTRNGIF_DATA;

	rTRNGIF_CTRL |= TRNGIF_CTRL_CLR_MASK;

	return random_value;
}

