// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : wdt_drv.c
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include "wdt_drv.h"


/*******************************************************************************
* Function Name  : WDT_Init
* Description    : WDTʼ
* Input          : - WMRCounterVal: Źֵ
*
* Output         : None
* Return         : None
******************************************************************************/
void WDT_Init(uint16_t WMRCounterVal)
{
	WDT->WDT_WMR = WMRCounterVal;
	WDT->WDT_WCR = WDT_EN;
}

void WDT_control(uint16_t WMRCounterVal,uint8_t EN)
{
	WDT->WDT_WMR = WMRCounterVal;       // WDT INIT VALUE
	
    WDT->WDT_WCR = EN;                  // 0:disable, 1:enable
										//WDT enable_reg,Can only be changed once
										//ʹVcommcu code,Ҫ,Ͽbusy,ֱӶϵϵ,ʹWDT
}



/*******************************************************************************
* Function Name  : WDT_FeedDog
* Description    : WDTι
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void WDT_FeedDog(void)
{
	WDT->WDT_WSR = 0x5555;
	WDT->WDT_WSR = 0xAAAA;
}

/*******************************************************************************
* Function Name  : WDT_Open
* Description    : WDT
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void WDT_Open(void)
{
	WDT->WDT_WCR |= WDT_EN;
}
/*******************************************************************************
* Function Name  : WDT_Close
* Description    : رWDT
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void WDT_Close(void)
{
	WDT->WDT_WCR &= ~WDT_EN;
}

/*******************************************************************************
* Function Name  : Get_WDTCount
* Description    : ȡWatch-dog counterֵ
* Input          : None
*
* Output         : Watch-dog counter
* Return         : None
******************************************************************************/
uint32_t Get_WDTCount(void)
{
	return (WDT->WDT_WCNTR);
}

