/*******************************************************************************
  * Copyright(c) 2023 Levetop Semiconductor Co.,Led. All rights reserved.   
  * @file     bsp_user.c
  * @author   UartTFT Application Team
  * @version  V0.0.1
  * @date     2023-01-01
  * @brief    This file contains customized functions written by the customer.
********************************************************************************/ 

#include "bsp_user.h"
#include "data.h"
#include "bsp.h"

uint8_t refresh_flag = 0; 

/********************************************************************************
* Function Name : cunstomize
* Description   : Custom function.
* Input         : - id: id for work
* Output        : None
* Return        : None
*********************************************************************************/
void cunstomize(uint16_t id)	// user define command
{
	 if(id == 1)
	 {
		 // automatically refresh when the variable changes or display when the page is just entered
		 if((var[0x1001*2 + 1] != var_temp[0x1001*2 + 1]) || refresh_flag == 1)
		 {
			// user part
			 
		 }
	 }
}
